//+------------------------------------------------------------------+
//|                                                       K3M_M1.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright sheker"
#property link      "http:"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Gray
#property indicator_color4 Blue
#property indicator_level1     80
#property indicator_level2     20
#property indicator_levelcolor DarkSlateGray
//---- input parameters
extern int kpi=10;
extern int dpi=3;
extern int spi=3;
//---- buffers
double Uptrend[];
double Downtrend[];
double MainBuffer[];
double SignalBuffer[];
double HighesBuffer[];
double LowesBuffer[];

//----
int draw_begin1=0;
int draw_begin2=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator lines
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 4);
   SetIndexBuffer(0, Uptrend);
   SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, 3);
   SetIndexBuffer(1, Downtrend);   
     
//----New

   SetIndexBuffer(2, MainBuffer);
   SetIndexBuffer(3, SignalBuffer);   

//---- 2 additional buffers are used for counting.
   SetIndexBuffer(4, HighesBuffer);
   SetIndexBuffer(5, LowesBuffer);

//---- name for DataWindow and indicator subwindow label
   short_name="K3M_M2 sto ("+kpi+","+dpi+","+spi+")!obos ";
  IndicatorShortName(short_name);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Stochastic oscillator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double price;
//----
   if(Bars<=draw_begin2) return(0);
//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=draw_begin1;i++) MainBuffer[Bars-i]=0;
      for(i=1;i<=draw_begin2;i++) SignalBuffer[Bars-i]=0;
      //Uptrend[i]=0;
      //Downtrend[i]=0;
     }
//---- minimums counting
   i=Bars-kpi;
   if(counted_bars>kpi) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double min=1000000;
      k=i+kpi-1;
      while(k>=i)
        {
         price=Low[k];
         if(min>price) min=price;
         k--;
        }
      LowesBuffer[i]=min;
      i--;
     }
//---- maximums counting
   i=Bars-kpi;
   if(counted_bars>kpi) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double max=-1000000;
      k=i+kpi-1;
      while(k>=i)
        {
         price=High[k];
         if(max<price) max=price;
         k--;
        }
      HighesBuffer[i]=max;
      i--;
     }
//---- %K line
   i=Bars-draw_begin1;
   if(counted_bars>draw_begin1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double sumlow=0.0;
      double sumhigh=0.0;
      for(k=(i+spi-1);k>=i;k--)
        {
         sumlow+=Close[k]-LowesBuffer[k];
         sumhigh+=HighesBuffer[k]-LowesBuffer[k];
        }
      if(sumhigh==0.0) MainBuffer[i]=100.0;
      else MainBuffer[i]=sumlow/sumhigh*100;
      
      i--;
     }
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
//---- signal line is simple movimg average
       for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MainBuffer,Bars,dpi,0,MODE_SMA,i);  
            
  
  
   i=Bars-kpi;
   if(counted_bars>kpi) i=Bars-counted_bars-1;
   while(i>=0)
  {          
if(MainBuffer[i]>=SignalBuffer[i]&&SignalBuffer[i]<80&& SignalBuffer[i]>20) Uptrend[i]=50;
else Uptrend[i]=0;
if(MainBuffer[i]<SignalBuffer[i]&&SignalBuffer[i]<80&& SignalBuffer[i]>20) Downtrend[i]=50;  
else Downtrend[i]=0;
      i--;
     }            
                 
//----
   return(0);
  }
//+------------------------------------------------------------------+